blob: f4e5f4ee6e5a78d375ca1a2dddaa4b38ae93cb5e [file] [log] [blame]
Scott Anderson1a5fc952012-03-07 17:15:06 -08001function hmm() {
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07002cat <<EOF
Jeff Gastonc6dfc4e2017-05-30 17:12:37 -07003
4Run "m help" for help with the build system itself.
5
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08006Invoke ". build/envsetup.sh" from your shell to add the following functions to your environment:
Steven Moreland62054a42018-12-06 10:11:40 -08007- lunch: lunch <product_name>-<build_variant>
8 Selects <product_name> as the product to build, and <build_variant> as the variant to
9 build, and stores those selections in the environment to be read by subsequent
10 invocations of 'm' etc.
Elliott Hughesf71c05a2020-03-06 16:46:59 -080011- tapas: tapas [<App1> <App2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
Martin Stjernholmf692c752021-04-12 00:01:10 +010012 Sets up the build environment for building unbundled apps (APKs).
13- banchan: banchan <module1> [<module2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
14 Sets up the build environment for building unbundled modules (APEXes).
Anton Hanssonece9c482019-02-04 18:15:39 +000015- croot: Changes directory to the top of the tree, or a subdirectory thereof.
Steven Moreland62054a42018-12-06 10:11:40 -080016- m: Makes from the top of the tree.
Dan Willemsen67074fe2019-10-30 12:35:34 -070017- mm: Builds and installs all of the modules in the current directory, and their
18 dependencies.
19- mmm: Builds and installs all of the modules in the supplied directories, and their
20 dependencies.
Steven Moreland62054a42018-12-06 10:11:40 -080021 To limit the modules being built use the syntax: mmm dir/:target1,target2.
Dan Willemsen67074fe2019-10-30 12:35:34 -070022- mma: Same as 'mm'
23- mmma: Same as 'mmm'
Steven Moreland62054a42018-12-06 10:11:40 -080024- provision: Flash device with all required partitions. Options will be passed on to fastboot.
25- cgrep: Greps on all local C/C++ files.
26- ggrep: Greps on all local Gradle files.
Orion Hodson831472d2019-10-25 11:35:15 +010027- gogrep: Greps on all local Go files.
Steven Moreland62054a42018-12-06 10:11:40 -080028- jgrep: Greps on all local Java files.
Taesu Leeea0cecd2020-10-28 11:05:18 +090029- ktgrep: Greps on all local Kotlin files.
Steven Moreland62054a42018-12-06 10:11:40 -080030- resgrep: Greps on all local res/*.xml files.
31- mangrep: Greps on all local AndroidManifest.xml files.
Jaewoong Jung892d0fe2019-05-04 10:06:28 -070032- mgrep: Greps on all local Makefiles and *.bp files.
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -060033- owngrep: Greps on all local OWNERS files.
Alistair Delva176e5342021-02-22 13:31:26 -080034- rsgrep: Greps on all local Rust files.
Steven Moreland62054a42018-12-06 10:11:40 -080035- sepgrep: Greps on all local sepolicy files.
36- sgrep: Greps on all local source files.
37- godir: Go to the directory containing a file.
38- allmod: List all modules.
39- gomod: Go to the directory containing a module.
Rett Berg78d1c932019-01-24 14:34:23 -080040- pathmod: Get the directory containing a module.
Cole Faust24c36db2021-01-23 02:39:37 +000041- outmod: Gets the location of a module's installed outputs with a certain extension.
Joe Onorato2c1aa472021-02-25 16:42:39 -080042- dirmods: Gets the modules defined in a given directory.
Cole Faust24c36db2021-01-23 02:39:37 +000043- installmod: Adb installs a module's built APK.
44- refreshmod: Refresh list of modules for allmod/gomod/pathmod/outmod/installmod.
Steven Moreland74114f12020-09-10 01:23:32 +000045- syswrite: Remount partitions (e.g. system.img) as writable, rebooting if necessary.
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070046
Roland Levillain39341922015-10-20 12:48:19 +010047Environment options:
Steven Moreland115d1f52019-09-26 16:30:28 -070048- SANITIZE_HOST: Set to 'address' to use ASAN for all host modules.
Sasha Smundak9f27cc02019-01-31 13:25:31 -080049- ANDROID_QUIET_BUILD: set to 'true' to display only the essential messages.
Dan Albert4ae5d4b2014-10-31 16:23:08 -070050
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070051Look at the source to view more functions. The complete list is:
52EOF
Christopher Ferris55257d22017-03-23 11:08:58 -070053 local T=$(gettop)
54 local A=""
55 local i
Jacky Cao89483b82015-05-15 22:12:53 +080056 for i in `cat $T/build/envsetup.sh | sed -n "/^[[:blank:]]*function /s/function \([a-z_]*\).*/\1/p" | sort | uniq`; do
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070057 A="$A $i"
58 done
59 echo $A
60}
61
Ying Wang08800fd2016-03-03 20:57:21 -080062# Get all the build variables needed by this script in a single call to the build system.
Matt Alexanderd9c56562020-05-21 10:49:17 +000063function build_build_var_cache()
64{
Christopher Ferris55257d22017-03-23 11:08:58 -070065 local T=$(gettop)
Ying Wang08800fd2016-03-03 20:57:21 -080066 # Grep out the variable names from the script.
Jim Tanga881a252018-06-19 16:34:41 +080067 cached_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
68 cached_abs_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_abs_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
Ying Wang08800fd2016-03-03 20:57:21 -080069 # Call the build system to dump the "<val>=<value>" pairs as a shell script.
Steven Moreland05402962018-01-05 12:13:11 -080070 build_dicts_script=`\builtin cd $T; build/soong/soong_ui.bash --dumpvars-mode \
Jim Tanga881a252018-06-19 16:34:41 +080071 --vars="${cached_vars[*]}" \
72 --abs-vars="${cached_abs_vars[*]}" \
Dan Willemsenaf88c412017-07-14 11:29:44 -070073 --var-prefix=var_cache_ \
74 --abs-var-prefix=abs_var_cache_`
Ying Wang08800fd2016-03-03 20:57:21 -080075 local ret=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +000076 if [ $ret -ne 0 ]
77 then
Ying Wang08800fd2016-03-03 20:57:21 -080078 unset build_dicts_script
79 return $ret
80 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -070081 # Execute the script to store the "<val>=<value>" pairs as shell variables.
Ying Wang08800fd2016-03-03 20:57:21 -080082 eval "$build_dicts_script"
Ying Wang08800fd2016-03-03 20:57:21 -080083 ret=$?
Ying Wangf0cb3972016-03-04 13:56:23 -080084 unset build_dicts_script
Matt Alexanderd9c56562020-05-21 10:49:17 +000085 if [ $ret -ne 0 ]
86 then
Ying Wang08800fd2016-03-03 20:57:21 -080087 return $ret
88 fi
89 BUILD_VAR_CACHE_READY="true"
90}
91
Ying Wangf0cb3972016-03-04 13:56:23 -080092# Delete the build var cache, so that we can still call into the build system
Ying Wang08800fd2016-03-03 20:57:21 -080093# to get build variables not listed in this script.
Matt Alexanderd9c56562020-05-21 10:49:17 +000094function destroy_build_var_cache()
95{
Ying Wang08800fd2016-03-03 20:57:21 -080096 unset BUILD_VAR_CACHE_READY
Christopher Ferris55257d22017-03-23 11:08:58 -070097 local v
Ying Wang08800fd2016-03-03 20:57:21 -080098 for v in $cached_vars; do
99 unset var_cache_$v
100 done
101 unset cached_vars
102 for v in $cached_abs_vars; do
103 unset abs_var_cache_$v
104 done
105 unset cached_abs_vars
106}
107
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700108# Get the value of a build variable as an absolute path.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000109function get_abs_build_var()
110{
111 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
112 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800113 eval "echo \"\${abs_var_cache_$1}\""
Matt Alexanderd9c56562020-05-21 10:49:17 +0000114 return
Ying Wang08800fd2016-03-03 20:57:21 -0800115 fi
116
Christopher Ferris55257d22017-03-23 11:08:58 -0700117 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700118 if [ ! "$T" ]; then
119 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
120 return
121 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700122 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode --abs $1)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700123}
124
125# Get the exact value of a build variable.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000126function get_build_var()
127{
128 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
129 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800130 eval "echo \"\${var_cache_$1}\""
Roland Levillain23c46cf2020-03-31 16:11:05 +0100131 return 0
Ying Wang08800fd2016-03-03 20:57:21 -0800132 fi
133
Christopher Ferris55257d22017-03-23 11:08:58 -0700134 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700135 if [ ! "$T" ]; then
136 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
Roland Levillain23c46cf2020-03-31 16:11:05 +0100137 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700138 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700139 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode $1)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800140}
141
142# check to see if the supplied product is one we can build
Matt Alexanderd9c56562020-05-21 10:49:17 +0000143function check_product()
144{
Christopher Ferris55257d22017-03-23 11:08:58 -0700145 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800146 if [ ! "$T" ]; then
147 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
148 return
149 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700150 TARGET_PRODUCT=$1 \
151 TARGET_BUILD_VARIANT= \
152 TARGET_BUILD_TYPE= \
Joe Onoratoda12daf2010-06-09 18:18:31 -0700153 TARGET_BUILD_APPS= \
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800154 get_build_var TARGET_DEVICE > /dev/null
155 # hide successful answers, but allow the errors to show
156}
157
158VARIANT_CHOICES=(user userdebug eng)
159
160# check to see if the supplied variant is valid
Matt Alexanderd9c56562020-05-21 10:49:17 +0000161function check_variant()
162{
Christopher Ferris55257d22017-03-23 11:08:58 -0700163 local v
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800164 for v in ${VARIANT_CHOICES[@]}
165 do
Matt Alexanderd9c56562020-05-21 10:49:17 +0000166 if [ "$v" = "$1" ]
167 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800168 return 0
169 fi
170 done
171 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700172}
173
Matt Alexanderd9c56562020-05-21 10:49:17 +0000174function setpaths()
175{
Christopher Ferris55257d22017-03-23 11:08:58 -0700176 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700177 if [ ! "$T" ]; then
178 echo "Couldn't locate the top of the tree. Try setting TOP."
179 return
180 fi
181
182 ##################################################################
183 # #
184 # Read me before you modify this code #
185 # #
186 # This function sets ANDROID_BUILD_PATHS to what it is adding #
187 # to PATH, and the next time it is run, it removes that from #
188 # PATH. This is required so lunch can be run more than once #
189 # and still have working paths. #
190 # #
191 ##################################################################
192
Raphael Mollc639c782011-06-20 17:25:01 -0700193 # Note: on windows/cygwin, ANDROID_BUILD_PATHS will contain spaces
194 # due to "C:\Program Files" being in the path.
195
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700196 # out with the old
Matt Alexanderd9c56562020-05-21 10:49:17 +0000197 if [ -n "$ANDROID_BUILD_PATHS" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700198 export PATH=${PATH/$ANDROID_BUILD_PATHS/}
199 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000200 if [ -n "$ANDROID_PRE_BUILD_PATHS" ] ; then
Doug Zongker29034982011-04-22 08:16:56 -0700201 export PATH=${PATH/$ANDROID_PRE_BUILD_PATHS/}
Ying Wangaa1c9b52012-11-26 20:51:59 -0800202 # strip leading ':', if any
203 export PATH=${PATH/:%/}
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500204 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700205
206 # and in with the new
Christopher Ferris55257d22017-03-23 11:08:58 -0700207 local prebuiltdir=$(getprebuilt)
208 local gccprebuiltdir=$(get_abs_build_var ANDROID_GCC_PREBUILTS)
Raphael732936d2011-06-22 14:35:32 -0700209
Ben Cheng8bc4c432012-11-16 13:29:13 -0800210 # defined in core/config.mk
Christopher Ferris55257d22017-03-23 11:08:58 -0700211 local targetgccversion=$(get_build_var TARGET_GCC_VERSION)
212 local targetgccversion2=$(get_build_var 2ND_TARGET_GCC_VERSION)
Ben Cheng15266702012-12-10 16:04:39 -0800213 export TARGET_GCC_VERSION=$targetgccversion
Ben Cheng8bc4c432012-11-16 13:29:13 -0800214
Raphael Mollc639c782011-06-20 17:25:01 -0700215 # The gcc toolchain does not exists for windows/cygwin. In this case, do not reference it.
Ben Chengfba67bf2014-02-25 10:27:07 -0800216 export ANDROID_TOOLCHAIN=
217 export ANDROID_TOOLCHAIN_2ND_ARCH=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200218 local ARCH=$(get_build_var TARGET_ARCH)
Christopher Ferris55257d22017-03-23 11:08:58 -0700219 local toolchaindir toolchaindir2=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200220 case $ARCH in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000221 x86) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Mark D Horn7d0ede72012-03-14 14:20:30 -0700222 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000223 x86_64) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Pavel Chupinfd82a492012-11-26 09:50:07 +0400224 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000225 arm) toolchaindir=arm/arm-linux-androideabi-$targetgccversion/bin
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200226 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000227 arm64) toolchaindir=aarch64/aarch64-linux-android-$targetgccversion/bin;
228 toolchaindir2=arm/arm-linux-androideabi-$targetgccversion2/bin
Ben Chengdb4fc202013-10-04 16:02:59 -0700229 ;;
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200230 *)
231 echo "Can't find toolchain for unknown architecture: $ARCH"
232 toolchaindir=xxxxxxxxx
Mark D Horn7d0ede72012-03-14 14:20:30 -0700233 ;;
234 esac
Jing Yuf5172c72012-03-29 20:45:50 -0700235 if [ -d "$gccprebuiltdir/$toolchaindir" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800236 export ANDROID_TOOLCHAIN=$gccprebuiltdir/$toolchaindir
Raphael Mollc639c782011-06-20 17:25:01 -0700237 fi
Raphael732936d2011-06-22 14:35:32 -0700238
Christopher Ferris55257d22017-03-23 11:08:58 -0700239 if [ "$toolchaindir2" -a -d "$gccprebuiltdir/$toolchaindir2" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800240 export ANDROID_TOOLCHAIN_2ND_ARCH=$gccprebuiltdir/$toolchaindir2
241 fi
242
Jeff Vander Stoep5f50f052015-06-12 09:56:39 -0700243 export ANDROID_DEV_SCRIPTS=$T/development/scripts:$T/prebuilts/devtools/tools:$T/external/selinux/prebuilts/bin
Yueyao Zhuefc786a2017-04-07 14:11:54 -0700244
245 # add kernel specific binaries
246 case $(uname -s) in
247 Linux)
248 export ANDROID_DEV_SCRIPTS=$ANDROID_DEV_SCRIPTS:$T/prebuilts/misc/linux-x86/dtc:$T/prebuilts/misc/linux-x86/libufdt
249 ;;
250 *)
251 ;;
252 esac
253
Torne (Richard Coles)0091bae2017-10-03 16:31:18 -0400254 ANDROID_BUILD_PATHS=$(get_build_var ANDROID_BUILD_PATHS):$ANDROID_TOOLCHAIN
255 if [ -n "$ANDROID_TOOLCHAIN_2ND_ARCH" ]; then
256 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_TOOLCHAIN_2ND_ARCH
257 fi
Yi Kongdfd00b12019-05-21 16:00:04 -0700258 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_DEV_SCRIPTS
259
260 # Append llvm binutils prebuilts path to ANDROID_BUILD_PATHS.
261 local ANDROID_LLVM_BINUTILS=$(get_abs_build_var ANDROID_CLANG_PREBUILTS)/llvm-binutils-stable
262 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_LLVM_BINUTILS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200263
Stephen Hinesaa8d72c2020-02-04 09:15:18 -0800264 # Set up ASAN_SYMBOLIZER_PATH for SANITIZE_HOST=address builds.
265 export ASAN_SYMBOLIZER_PATH=$ANDROID_LLVM_BINUTILS/llvm-symbolizer
266
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200267 # If prebuilts/android-emulator/<system>/ exists, prepend it to our PATH
268 # to ensure that the corresponding 'emulator' binaries are used.
269 case $(uname -s) in
270 Darwin)
271 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/darwin-x86_64
272 ;;
273 Linux)
274 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/linux-x86_64
275 ;;
276 *)
277 ANDROID_EMULATOR_PREBUILTS=
278 ;;
279 esac
280 if [ -n "$ANDROID_EMULATOR_PREBUILTS" -a -d "$ANDROID_EMULATOR_PREBUILTS" ]; then
Yi Kongdfd00b12019-05-21 16:00:04 -0700281 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_EMULATOR_PREBUILTS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200282 export ANDROID_EMULATOR_PREBUILTS
283 fi
284
Jim Tangb3fda302018-12-22 10:24:55 +0800285 # Append asuite prebuilts path to ANDROID_BUILD_PATHS.
286 local os_arch=$(get_build_var HOST_PREBUILT_TAG)
Ryan Prichard8426a192019-07-15 18:05:29 -0700287 local ACLOUD_PATH="$T/prebuilts/asuite/acloud/$os_arch"
288 local AIDEGEN_PATH="$T/prebuilts/asuite/aidegen/$os_arch"
289 local ATEST_PATH="$T/prebuilts/asuite/atest/$os_arch"
290 export ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ACLOUD_PATH:$AIDEGEN_PATH:$ATEST_PATH:
Jim Tangb3fda302018-12-22 10:24:55 +0800291
Ryan Prichard8426a192019-07-15 18:05:29 -0700292 export PATH=$ANDROID_BUILD_PATHS$PATH
Jim Tang22f4c322018-12-17 15:21:53 +0800293
294 # out with the duplicate old
295 if [ -n $ANDROID_PYTHONPATH ]; then
296 export PYTHONPATH=${PYTHONPATH//$ANDROID_PYTHONPATH/}
297 fi
298 # and in with the new
299 export ANDROID_PYTHONPATH=$T/development/python-packages:
Jim Tangc4dba1d2019-07-25 16:54:27 +0800300 if [ -n $VENDOR_PYTHONPATH ]; then
301 ANDROID_PYTHONPATH=$ANDROID_PYTHONPATH$VENDOR_PYTHONPATH
302 fi
Jim Tang22f4c322018-12-17 15:21:53 +0800303 export PYTHONPATH=$ANDROID_PYTHONPATH$PYTHONPATH
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800304
Colin Crosse97e6932017-06-30 16:01:45 -0700305 export ANDROID_JAVA_HOME=$(get_abs_build_var ANDROID_JAVA_HOME)
306 export JAVA_HOME=$ANDROID_JAVA_HOME
307 export ANDROID_JAVA_TOOLCHAIN=$(get_abs_build_var ANDROID_JAVA_TOOLCHAIN)
308 export ANDROID_PRE_BUILD_PATHS=$ANDROID_JAVA_TOOLCHAIN:
309 export PATH=$ANDROID_PRE_BUILD_PATHS$PATH
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500310
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800311 unset ANDROID_PRODUCT_OUT
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700312 export ANDROID_PRODUCT_OUT=$(get_abs_build_var PRODUCT_OUT)
313 export OUT=$ANDROID_PRODUCT_OUT
314
Jeff Brown8fd5cce2011-03-24 17:03:06 -0700315 unset ANDROID_HOST_OUT
316 export ANDROID_HOST_OUT=$(get_abs_build_var HOST_OUT)
317
Jiyong Parkc02b1c42020-11-03 11:06:39 +0900318 unset ANDROID_SOONG_HOST_OUT
319 export ANDROID_SOONG_HOST_OUT=$(get_abs_build_var SOONG_HOST_OUT)
320
Simran Basidd050ed2017-02-13 13:46:48 -0800321 unset ANDROID_HOST_OUT_TESTCASES
322 export ANDROID_HOST_OUT_TESTCASES=$(get_abs_build_var HOST_OUT_TESTCASES)
323
324 unset ANDROID_TARGET_OUT_TESTCASES
325 export ANDROID_TARGET_OUT_TESTCASES=$(get_abs_build_var TARGET_OUT_TESTCASES)
326
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800327 # needed for building linux on MacOS
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700328 # TODO: fix the path
329 #export HOST_EXTRACFLAGS="-I "$T/system/kernel_headers/host_include
330}
331
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000332function bazel()
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000333{
334 local T="$(gettop)"
335 if [ ! "$T" ]; then
336 echo "Couldn't locate the top of the tree. Try setting TOP."
337 return
338 fi
339
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000340 if which bazel &>/dev/null; then
Jingwen Chenc8b5e192020-12-14 10:28:33 -0500341 >&2 echo "NOTE: bazel() function sourced from envsetup.sh is being used instead of $(which bazel)"
342 >&2 echo
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000343 fi
344
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000345 "$T/tools/bazel" "$@"
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000346}
347
Matt Alexanderd9c56562020-05-21 10:49:17 +0000348function printconfig()
349{
Christopher Ferris55257d22017-03-23 11:08:58 -0700350 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800351 if [ ! "$T" ]; then
352 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
353 return
354 fi
355 get_build_var report_config
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700356}
357
Matt Alexanderd9c56562020-05-21 10:49:17 +0000358function set_stuff_for_environment()
359{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800360 setpaths
361 set_sequence_number
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700362
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800363 export ANDROID_BUILD_TOP=$(gettop)
Ben Chengaac3f812013-08-13 14:38:15 -0700364 # With this environment variable new GCC can apply colors to warnings/errors
365 export GCC_COLORS='error=01;31:warning=01;35:note=01;36:caret=01;32:locus=01:quote=01'
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700366}
367
Matt Alexanderd9c56562020-05-21 10:49:17 +0000368function set_sequence_number()
369{
Colin Cross88737132017-03-21 17:41:03 -0700370 export BUILD_ENV_SEQUENCE_NUMBER=13
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700371}
372
Makoto Onukida971062018-06-18 10:15:19 -0700373# Takes a command name, and check if it's in ENVSETUP_NO_COMPLETION or not.
374function should_add_completion() {
Jim Tanga881a252018-06-19 16:34:41 +0800375 local cmd="$(basename $1| sed 's/_completion//' |sed 's/\.\(.*\)*sh$//')"
Makoto Onukida971062018-06-18 10:15:19 -0700376 case :"$ENVSETUP_NO_COMPLETION": in
Jim Tanga881a252018-06-19 16:34:41 +0800377 *:"$cmd":*)
378 return 1
379 ;;
Makoto Onukida971062018-06-18 10:15:19 -0700380 esac
381 return 0
382}
383
Matt Alexanderd9c56562020-05-21 10:49:17 +0000384function addcompletions()
385{
Ben Taitelbaum8c2c9cf2020-09-22 16:45:05 -0700386 local f=
Kenny Root52aa81c2011-07-15 11:07:06 -0700387
Jim Tanga881a252018-06-19 16:34:41 +0800388 # Keep us from trying to run in something that's neither bash nor zsh.
389 if [ -z "$BASH_VERSION" -a -z "$ZSH_VERSION" ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700390 return
391 fi
392
393 # Keep us from trying to run in bash that's too old.
Jim Tanga881a252018-06-19 16:34:41 +0800394 if [ -n "$BASH_VERSION" -a ${BASH_VERSINFO[0]} -lt 3 ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700395 return
396 fi
397
Jim Tanga881a252018-06-19 16:34:41 +0800398 local completion_files=(
399 system/core/adb/adb.bash
400 system/core/fastboot/fastboot.bash
Jim Tangb3fda302018-12-22 10:24:55 +0800401 tools/asuite/asuite.sh
Jim Tanga881a252018-06-19 16:34:41 +0800402 )
Makoto Onukida971062018-06-18 10:15:19 -0700403 # Completion can be disabled selectively to allow users to use non-standard completion.
404 # e.g.
405 # ENVSETUP_NO_COMPLETION=adb # -> disable adb completion
406 # ENVSETUP_NO_COMPLETION=adb:bit # -> disable adb and bit completion
Jim Tanga881a252018-06-19 16:34:41 +0800407 for f in ${completion_files[*]}; do
408 if [ -f "$f" ] && should_add_completion "$f"; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700409 . $f
Elliott Hughesce18dd42018-04-03 13:49:48 -0700410 fi
411 done
Joe Onorato002a6c72016-10-20 16:39:49 -0700412
Matt Alexanderd9c56562020-05-21 10:49:17 +0000413 if should_add_completion bit ; then
Makoto Onukida971062018-06-18 10:15:19 -0700414 complete -C "bit --tab" bit
415 fi
Anton Hanssonece9c482019-02-04 18:15:39 +0000416 if [ -z "$ZSH_VERSION" ]; then
417 # Doesn't work in zsh.
418 complete -o nospace -F _croot croot
419 fi
Jim Tanga881a252018-06-19 16:34:41 +0800420 complete -F _lunch lunch
Steven Moreland62054a42018-12-06 10:11:40 -0800421
Cole Faust24c36db2021-01-23 02:39:37 +0000422 complete -F _complete_android_module_names pathmod
dimitry73b84812018-12-11 18:06:00 +0100423 complete -F _complete_android_module_names gomod
Cole Faust24c36db2021-01-23 02:39:37 +0000424 complete -F _complete_android_module_names outmod
425 complete -F _complete_android_module_names installmod
dimitry73b84812018-12-11 18:06:00 +0100426 complete -F _complete_android_module_names m
Kenny Root52aa81c2011-07-15 11:07:06 -0700427}
428
Matt Alexanderd9c56562020-05-21 10:49:17 +0000429function choosetype()
430{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700431 echo "Build type choices are:"
432 echo " 1. release"
433 echo " 2. debug"
434 echo
435
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800436 local DEFAULT_NUM DEFAULT_VALUE
Jeff Browne33ba4c2011-07-11 22:11:46 -0700437 DEFAULT_NUM=1
438 DEFAULT_VALUE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700439
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800440 export TARGET_BUILD_TYPE=
441 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700442 while [ -z $TARGET_BUILD_TYPE ]
443 do
444 echo -n "Which would you like? ["$DEFAULT_NUM"] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000445 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800446 read ANSWER
447 else
448 echo $1
449 ANSWER=$1
450 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700451 case $ANSWER in
452 "")
453 export TARGET_BUILD_TYPE=$DEFAULT_VALUE
454 ;;
455 1)
456 export TARGET_BUILD_TYPE=release
457 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800458 release)
459 export TARGET_BUILD_TYPE=release
460 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700461 2)
462 export TARGET_BUILD_TYPE=debug
463 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800464 debug)
465 export TARGET_BUILD_TYPE=debug
466 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700467 *)
468 echo
469 echo "I didn't understand your response. Please try again."
470 echo
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700471 ;;
472 esac
Matt Alexanderd9c56562020-05-21 10:49:17 +0000473 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800474 break
475 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700476 done
477
Ying Wang08800fd2016-03-03 20:57:21 -0800478 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700479 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800480 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700481}
482
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800483#
484# This function isn't really right: It chooses a TARGET_PRODUCT
485# based on the list of boards. Usually, that gets you something
486# that kinda works with a generic product, but really, you should
487# pick a product by name.
488#
Matt Alexanderd9c56562020-05-21 10:49:17 +0000489function chooseproduct()
490{
Christopher Ferris55257d22017-03-23 11:08:58 -0700491 local default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000492 if [ "x$TARGET_PRODUCT" != x ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700493 default_value=$TARGET_PRODUCT
494 else
Ying Wang0a76df52015-06-08 11:57:26 -0700495 default_value=aosp_arm
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700496 fi
497
Ying Wang08800fd2016-03-03 20:57:21 -0800498 export TARGET_BUILD_APPS=
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800499 export TARGET_PRODUCT=
500 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700501 while [ -z "$TARGET_PRODUCT" ]
502 do
Joe Onorato8849aed2009-04-29 15:56:47 -0700503 echo -n "Which product would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000504 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800505 read ANSWER
506 else
507 echo $1
508 ANSWER=$1
509 fi
510
Matt Alexanderd9c56562020-05-21 10:49:17 +0000511 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700512 export TARGET_PRODUCT=$default_value
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800513 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000514 if check_product $ANSWER
515 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800516 export TARGET_PRODUCT=$ANSWER
517 else
518 echo "** Not a valid product: $ANSWER"
519 fi
520 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000521 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800522 break
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700523 fi
524 done
525
Ying Wang08800fd2016-03-03 20:57:21 -0800526 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700527 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800528 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700529}
530
Matt Alexanderd9c56562020-05-21 10:49:17 +0000531function choosevariant()
532{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800533 echo "Variant choices are:"
534 local index=1
535 local v
536 for v in ${VARIANT_CHOICES[@]}
537 do
538 # The product name is the name of the directory containing
539 # the makefile we found, above.
540 echo " $index. $v"
541 index=$(($index+1))
542 done
543
544 local default_value=eng
545 local ANSWER
546
547 export TARGET_BUILD_VARIANT=
548 while [ -z "$TARGET_BUILD_VARIANT" ]
549 do
550 echo -n "Which would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000551 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800552 read ANSWER
553 else
554 echo $1
555 ANSWER=$1
556 fi
557
Matt Alexanderd9c56562020-05-21 10:49:17 +0000558 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800559 export TARGET_BUILD_VARIANT=$default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000560 elif (echo -n $ANSWER | grep -q -e "^[0-9][0-9]*$") ; then
561 if [ "$ANSWER" -le "${#VARIANT_CHOICES[@]}" ] ; then
Guillaume Chelfice000fd2019-10-03 12:02:46 +0200562 export TARGET_BUILD_VARIANT=${VARIANT_CHOICES[@]:$(($ANSWER-1)):1}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800563 fi
564 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000565 if check_variant $ANSWER
566 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800567 export TARGET_BUILD_VARIANT=$ANSWER
568 else
569 echo "** Not a valid variant: $ANSWER"
570 fi
571 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000572 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800573 break
574 fi
575 done
576}
577
Matt Alexanderd9c56562020-05-21 10:49:17 +0000578function choosecombo()
579{
Jeff Browne33ba4c2011-07-11 22:11:46 -0700580 choosetype $1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700581
582 echo
583 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700584 chooseproduct $2
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700585
586 echo
587 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700588 choosevariant $3
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800589
590 echo
Ying Wang08800fd2016-03-03 20:57:21 -0800591 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700592 set_stuff_for_environment
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800593 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800594 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700595}
596
Matt Alexanderd9c56562020-05-21 10:49:17 +0000597function add_lunch_combo()
598{
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800599 if [ -n "$ZSH_VERSION" ]; then
600 echo -n "${funcfiletrace[1]}: "
601 else
602 echo -n "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: "
603 fi
604 echo "add_lunch_combo is obsolete. Use COMMON_LUNCH_CHOICES in your AndroidProducts.mk instead."
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800605}
606
Matt Alexanderd9c56562020-05-21 10:49:17 +0000607function print_lunch_menu()
608{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700609 local uname=$(uname)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100610 local choices
611 choices=$(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES 2>/dev/null)
612 local ret=$?
613
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700614 echo
615 echo "You're building on" $uname
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700616 echo
Roland Levillain23c46cf2020-03-31 16:11:05 +0100617
Matt Alexanderd9c56562020-05-21 10:49:17 +0000618 if [ $ret -ne 0 ]
619 then
Roland Levillain23c46cf2020-03-31 16:11:05 +0100620 echo "Warning: Cannot display lunch menu."
621 echo
622 echo "Note: You can invoke lunch with an explicit target:"
623 echo
624 echo " usage: lunch [target]" >&2
625 echo
626 return
627 fi
628
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700629 echo "Lunch menu... pick a combo:"
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800630
631 local i=1
632 local choice
Dan Willemsen91763e92019-10-03 15:13:12 -0700633 for choice in $(echo $choices)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800634 do
635 echo " $i. $choice"
636 i=$(($i+1))
637 done
638
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700639 echo
640}
641
Matt Alexanderd9c56562020-05-21 10:49:17 +0000642function lunch()
643{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800644 local answer
645
Steven Moreland92793dc2020-02-25 18:30:18 -0800646 if [[ $# -gt 1 ]]; then
647 echo "usage: lunch [target]" >&2
648 return 1
649 fi
650
651 if [ "$1" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800652 answer=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700653 else
654 print_lunch_menu
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700655 echo -n "Which would you like? [aosp_arm-eng] "
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800656 read answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700657 fi
658
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800659 local selection=
660
Matt Alexanderd9c56562020-05-21 10:49:17 +0000661 if [ -z "$answer" ]
662 then
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700663 selection=aosp_arm-eng
Matt Alexanderd9c56562020-05-21 10:49:17 +0000664 elif (echo -n $answer | grep -q -e "^[0-9][0-9]*$")
665 then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800666 local choices=($(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES))
Matt Alexanderd9c56562020-05-21 10:49:17 +0000667 if [ $answer -le ${#choices[@]} ]
668 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800669 # array in zsh starts from 1 instead of 0.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000670 if [ -n "$ZSH_VERSION" ]
671 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800672 selection=${choices[$(($answer))]}
673 else
674 selection=${choices[$(($answer-1))]}
675 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800676 fi
Colin Cross88737132017-03-21 17:41:03 -0700677 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800678 selection=$answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700679 fi
680
Joe Onoratoda12daf2010-06-09 18:18:31 -0700681 export TARGET_BUILD_APPS=
682
Colin Cross88737132017-03-21 17:41:03 -0700683 local product variant_and_version variant version
Colin Cross88737132017-03-21 17:41:03 -0700684 product=${selection%%-*} # Trim everything after first dash
685 variant_and_version=${selection#*-} # Trim everything up to first dash
686 if [ "$variant_and_version" != "$selection" ]; then
687 variant=${variant_and_version%%-*}
688 if [ "$variant" != "$variant_and_version" ]; then
689 version=${variant_and_version#*-}
690 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700691 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800692
Matt Alexanderd9c56562020-05-21 10:49:17 +0000693 if [ -z "$product" ]
694 then
Ying Wang08800fd2016-03-03 20:57:21 -0800695 echo
Colin Cross88737132017-03-21 17:41:03 -0700696 echo "Invalid lunch combo: $selection"
Jeff Browne33ba4c2011-07-11 22:11:46 -0700697 return 1
698 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800699
Colin Cross88737132017-03-21 17:41:03 -0700700 TARGET_PRODUCT=$product \
701 TARGET_BUILD_VARIANT=$variant \
702 TARGET_PLATFORM_VERSION=$version \
703 build_build_var_cache
Matt Alexanderd9c56562020-05-21 10:49:17 +0000704 if [ $? -ne 0 ]
705 then
Colin Cross88737132017-03-21 17:41:03 -0700706 return 1
707 fi
Colin Cross88737132017-03-21 17:41:03 -0700708 export TARGET_PRODUCT=$(get_build_var TARGET_PRODUCT)
709 export TARGET_BUILD_VARIANT=$(get_build_var TARGET_BUILD_VARIANT)
Colin Crossb105e362017-05-01 14:21:28 -0700710 if [ -n "$version" ]; then
711 export TARGET_PLATFORM_VERSION=$(get_build_var TARGET_PLATFORM_VERSION)
712 else
713 unset TARGET_PLATFORM_VERSION
714 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700715 export TARGET_BUILD_TYPE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700716
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700717 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || echo
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800718
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700719 set_stuff_for_environment
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700720 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800721 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700722}
723
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700724unset COMMON_LUNCH_CHOICES_CACHE
Jeff Davidson513d7a42010-08-02 10:00:44 -0700725# Tab completion for lunch.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000726function _lunch()
727{
Jeff Davidson513d7a42010-08-02 10:00:44 -0700728 local cur prev opts
729 COMPREPLY=()
730 cur="${COMP_WORDS[COMP_CWORD]}"
731 prev="${COMP_WORDS[COMP_CWORD-1]}"
732
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700733 if [ -z "$COMMON_LUNCH_CHOICES_CACHE" ]; then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800734 COMMON_LUNCH_CHOICES_CACHE=$(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES)
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700735 fi
736
737 COMPREPLY=( $(compgen -W "${COMMON_LUNCH_CHOICES_CACHE}" -- ${cur}) )
Jeff Davidson513d7a42010-08-02 10:00:44 -0700738 return 0
739}
Jeff Davidson513d7a42010-08-02 10:00:44 -0700740
Joe Onoratoda12daf2010-06-09 18:18:31 -0700741# Configures the build to build unbundled apps.
Doug Zongker0d8179e2014-04-16 11:34:34 -0700742# Run tapas with one or more app names (from LOCAL_PACKAGE_NAME)
Matt Alexanderd9c56562020-05-21 10:49:17 +0000743function tapas()
744{
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700745 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800746 local arch="$(echo $* | xargs -n 1 echo | \grep -E '^(arm|x86|arm64|x86_64)$' | xargs)"
Doug Zongker0d8179e2014-04-16 11:34:34 -0700747 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700748 local density="$(echo $* | xargs -n 1 echo | \grep -E '^(ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800749 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|arm|x86|arm64|x86_64|ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Joe Onoratoda12daf2010-06-09 18:18:31 -0700750
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700751 if [ "$showHelp" != "" ]; then
752 $(gettop)/build/make/tapasHelp.sh
753 return
754 fi
755
Ying Wang67f02922012-08-22 10:25:20 -0700756 if [ $(echo $arch | wc -w) -gt 1 ]; then
757 echo "tapas: Error: Multiple build archs supplied: $arch"
758 return
759 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700760 if [ $(echo $variant | wc -w) -gt 1 ]; then
761 echo "tapas: Error: Multiple build variants supplied: $variant"
762 return
763 fi
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700764 if [ $(echo $density | wc -w) -gt 1 ]; then
765 echo "tapas: Error: Multiple densities supplied: $density"
766 return
767 fi
Ying Wang67f02922012-08-22 10:25:20 -0700768
Ying Wang0a76df52015-06-08 11:57:26 -0700769 local product=aosp_arm
Ying Wang67f02922012-08-22 10:25:20 -0700770 case $arch in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000771 x86) product=aosp_x86;;
772 arm64) product=aosp_arm64;;
773 x86_64) product=aosp_x86_64;;
Ying Wang67f02922012-08-22 10:25:20 -0700774 esac
Joe Onoratoda12daf2010-06-09 18:18:31 -0700775 if [ -z "$variant" ]; then
776 variant=eng
777 fi
Ying Wangc048c9b2010-06-24 15:08:33 -0700778 if [ -z "$apps" ]; then
779 apps=all
780 fi
Justin Morey29d225c2014-11-04 13:35:51 -0600781 if [ -z "$density" ]; then
782 density=alldpi
783 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700784
Ying Wang67f02922012-08-22 10:25:20 -0700785 export TARGET_PRODUCT=$product
Joe Onoratoda12daf2010-06-09 18:18:31 -0700786 export TARGET_BUILD_VARIANT=$variant
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700787 export TARGET_BUILD_DENSITY=$density
Joe Onoratoda12daf2010-06-09 18:18:31 -0700788 export TARGET_BUILD_TYPE=release
789 export TARGET_BUILD_APPS=$apps
790
Ying Wang08800fd2016-03-03 20:57:21 -0800791 build_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700792 set_stuff_for_environment
793 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800794 destroy_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700795}
796
Martin Stjernholmf692c752021-04-12 00:01:10 +0100797# Configures the build to build unbundled Android modules (APEXes).
798# Run banchan with one or more module names (from apex{} modules).
799function banchan()
800{
801 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
802 local arch="$(echo $* | xargs -n 1 echo | \grep -E '^(arm|x86|arm64|x86_64)$' | xargs)"
803 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
804 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|arm|x86|arm64|x86_64)$' | xargs)"
805
806 if [ "$showHelp" != "" ]; then
807 $(gettop)/build/make/banchanHelp.sh
808 return
809 fi
810
811 if [ $(echo $arch | wc -w) -gt 1 ]; then
812 echo "banchan: Error: Multiple build archs supplied: $arch"
813 return
814 fi
815 if [ $(echo $variant | wc -w) -gt 1 ]; then
816 echo "banchan: Error: Multiple build variants supplied: $variant"
817 return
818 fi
819 if [ -z "$apps" ]; then
820 echo "banchan: Error: No modules supplied"
821 return
822 fi
823
824 local product=module_arm
825 case $arch in
826 x86) product=module_x86;;
827 arm64) product=module_arm64;;
828 x86_64) product=module_x86_64;;
829 esac
830 if [ -z "$variant" ]; then
831 variant=eng
832 fi
833
834 export TARGET_PRODUCT=$product
835 export TARGET_BUILD_VARIANT=$variant
836 export TARGET_BUILD_DENSITY=alldpi
837 export TARGET_BUILD_TYPE=release
838
839 # This setup currently uses TARGET_BUILD_APPS just like tapas, but the use
840 # case is different and it may diverge in the future.
841 export TARGET_BUILD_APPS=$apps
842
843 build_build_var_cache
844 set_stuff_for_environment
845 printconfig
846 destroy_build_var_cache
847}
848
Matt Alexanderd9c56562020-05-21 10:49:17 +0000849function gettop
850{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700851 local TOPFILE=build/make/core/envsetup.mk
Matt Alexanderd9c56562020-05-21 10:49:17 +0000852 if [ -n "$TOP" -a -f "$TOP/$TOPFILE" ] ; then
Brian Carlstroma5c4f172014-09-12 00:33:25 -0700853 # The following circumlocution ensures we remove symlinks from TOP.
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000854 (cd "$TOP"; PWD= /bin/pwd)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700855 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000856 if [ -f $TOPFILE ] ; then
Dan Bornsteind0b274d2009-11-24 15:48:50 -0800857 # The following circumlocution (repeated below as well) ensures
858 # that we record the true directory name and not one that is
859 # faked up with symlink names.
860 PWD= /bin/pwd
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700861 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800862 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700863 local T=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000864 while [ \( ! \( -f $TOPFILE \) \) -a \( "$PWD" != "/" \) ]; do
Ying Wang9cd17642012-12-13 10:52:07 -0800865 \cd ..
synergyb112a402013-07-05 19:47:47 -0700866 T=`PWD= /bin/pwd -P`
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700867 done
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000868 \cd "$HERE"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700869 if [ -f "$T/$TOPFILE" ]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000870 echo "$T"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700871 fi
872 fi
873 fi
874}
875
Matt Alexanderd9c56562020-05-21 10:49:17 +0000876function croot()
877{
Christopher Ferris55257d22017-03-23 11:08:58 -0700878 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700879 if [ "$T" ]; then
Marie Janssen32ec50a2016-04-21 16:53:39 -0700880 if [ "$1" ]; then
881 \cd $(gettop)/$1
882 else
883 \cd $(gettop)
884 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700885 else
886 echo "Couldn't locate the top of the tree. Try setting TOP."
887 fi
888}
889
Matt Alexanderd9c56562020-05-21 10:49:17 +0000890function _croot()
891{
Anton Hanssonece9c482019-02-04 18:15:39 +0000892 local T=$(gettop)
893 if [ "$T" ]; then
894 local cur="${COMP_WORDS[COMP_CWORD]}"
895 k=0
896 for c in $(compgen -d ${T}/${cur}); do
897 COMPREPLY[k++]=${c#${T}/}/
898 done
899 fi
900}
901
Matt Alexanderd9c56562020-05-21 10:49:17 +0000902function cproj()
903{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700904 local TOPFILE=build/make/core/envsetup.mk
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700905 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700906 local T=
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700907 while [ \( ! \( -f $TOPFILE \) \) -a \( $PWD != "/" \) ]; do
908 T=$PWD
909 if [ -f "$T/Android.mk" ]; then
Ying Wang9cd17642012-12-13 10:52:07 -0800910 \cd $T
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700911 return
912 fi
Ying Wang9cd17642012-12-13 10:52:07 -0800913 \cd ..
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700914 done
Ying Wang9cd17642012-12-13 10:52:07 -0800915 \cd $HERE
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700916 echo "can't find Android.mk"
917}
918
Daniel Sandler47e0a882013-07-30 13:23:52 -0400919# simplified version of ps; output in the form
920# <pid> <procname>
921function qpid() {
922 local prepend=''
923 local append=''
Matt Alexanderd9c56562020-05-21 10:49:17 +0000924 if [ "$1" = "--exact" ]; then
Daniel Sandler47e0a882013-07-30 13:23:52 -0400925 prepend=' '
926 append='$'
927 shift
Matt Alexanderd9c56562020-05-21 10:49:17 +0000928 elif [ "$1" = "--help" -o "$1" = "-h" ]; then
Ying Wang08800fd2016-03-03 20:57:21 -0800929 echo "usage: qpid [[--exact] <process name|pid>"
930 return 255
931 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -0400932
933 local EXE="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +0000934 if [ "$EXE" ] ; then
Ying Wang08800fd2016-03-03 20:57:21 -0800935 qpid | \grep "$prepend$EXE$append"
936 else
937 adb shell ps \
938 | tr -d '\r' \
939 | sed -e 1d -e 's/^[^ ]* *\([0-9]*\).* \([^ ]*\)$/\1 \2/'
940 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -0400941}
942
Steven Moreland74114f12020-09-10 01:23:32 +0000943# syswrite - disable verity, reboot if needed, and remount image
944#
945# Easy way to make system.img/etc writable
946function syswrite() {
947 adb wait-for-device && adb root || return 1
948 if [[ $(adb disable-verity | grep "reboot") ]]; then
949 echo "rebooting"
950 adb reboot && adb wait-for-device && adb root || return 1
951 fi
952 adb wait-for-device && adb remount || return 1
953}
954
Iliyan Malcheve675cfb2014-11-03 17:04:47 -0800955# coredump_setup - enable core dumps globally for any process
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700956# that has the core-file-size limit set correctly
957#
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800958# NOTE: You must call also coredump_enable for a specific process
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700959# if its core-file-size limit is not set already.
960# NOTE: Core dumps are written to ramdisk; they will not survive a reboot!
961
Matt Alexanderd9c56562020-05-21 10:49:17 +0000962function coredump_setup()
963{
964 echo "Getting root...";
965 adb root;
966 adb wait-for-device;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700967
Matt Alexanderd9c56562020-05-21 10:49:17 +0000968 echo "Remounting root partition read-write...";
969 adb shell mount -w -o remount -t rootfs rootfs;
970 sleep 1;
971 adb wait-for-device;
972 adb shell mkdir -p /cores;
973 adb shell mount -t tmpfs tmpfs /cores;
974 adb shell chmod 0777 /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700975
Matt Alexanderd9c56562020-05-21 10:49:17 +0000976 echo "Granting SELinux permission to dump in /cores...";
977 adb shell restorecon -R /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700978
Matt Alexanderd9c56562020-05-21 10:49:17 +0000979 echo "Set core pattern.";
980 adb shell 'echo /cores/core.%p > /proc/sys/kernel/core_pattern';
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700981
Ying Wang08800fd2016-03-03 20:57:21 -0800982 echo "Done."
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700983}
984
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800985# coredump_enable - enable core dumps for the specified process
Matt Alexanderd9c56562020-05-21 10:49:17 +0000986# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700987#
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800988# NOTE: coredump_setup must have been called as well for a core
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700989# dump to actually be generated.
990
Matt Alexanderd9c56562020-05-21 10:49:17 +0000991function coredump_enable()
992{
993 local PID=$1;
Ying Wang08800fd2016-03-03 20:57:21 -0800994 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +0000995 printf "Expecting a PID!\n";
996 return;
997 fi;
998 echo "Setting core limit for $PID to infinite...";
Elliott Hughes910a3552016-03-07 13:53:53 -0800999 adb shell /system/bin/ulimit -p $PID -c unlimited
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001000}
1001
1002# core - send SIGV and pull the core for process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001003# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001004#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001005# NOTE: coredump_setup must be called once per boot for core dumps to be
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001006# enabled globally.
1007
Matt Alexanderd9c56562020-05-21 10:49:17 +00001008function core()
1009{
1010 local PID=$1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001011
Ying Wang08800fd2016-03-03 20:57:21 -08001012 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001013 printf "Expecting a PID!\n";
1014 return;
1015 fi;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001016
Matt Alexanderd9c56562020-05-21 10:49:17 +00001017 local CORENAME=core.$PID;
1018 local COREPATH=/cores/$CORENAME;
1019 local SIG=SEGV;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001020
Matt Alexanderd9c56562020-05-21 10:49:17 +00001021 coredump_enable $1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001022
Matt Alexanderd9c56562020-05-21 10:49:17 +00001023 local done=0;
Ying Wang08800fd2016-03-03 20:57:21 -08001024 while [ $(adb shell "[ -d /proc/$PID ] && echo -n yes") ]; do
Matt Alexanderd9c56562020-05-21 10:49:17 +00001025 printf "\tSending SIG%s to %d...\n" $SIG $PID;
1026 adb shell kill -$SIG $PID;
1027 sleep 1;
1028 done;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001029
Matt Alexanderd9c56562020-05-21 10:49:17 +00001030 adb shell "while [ ! -f $COREPATH ] ; do echo waiting for $COREPATH to be generated; sleep 1; done"
1031 echo "Done: core is under $COREPATH on device.";
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001032}
1033
Christopher Tate744ee802009-11-12 15:33:08 -08001034# systemstack - dump the current stack trace of all threads in the system process
1035# to the usual ANR traces file
Matt Alexanderd9c56562020-05-21 10:49:17 +00001036function systemstack()
1037{
Jeff Sharkeyf5824372013-02-19 17:00:46 -08001038 stacks system_server
1039}
1040
Michael Wrightaeed7212014-06-19 19:58:12 -07001041# Read the ELF header from /proc/$PID/exe to determine if the process is
1042# 64-bit.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001043function is64bit()
1044{
Ben Chengfba67bf2014-02-25 10:27:07 -08001045 local PID="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001046 if [ "$PID" ] ; then
1047 if [[ "$(adb shell cat /proc/$PID/exe | xxd -l 1 -s 4 -p)" -eq "02" ]] ; then
Ben Chengfba67bf2014-02-25 10:27:07 -08001048 echo "64"
1049 else
1050 echo ""
1051 fi
1052 else
1053 echo ""
1054 fi
1055}
1056
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001057case `uname -s` in
1058 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001059 function sgrep()
1060 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001061 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cc|cpp|hpp|S|java|kt|xml|sh|mk|aidl|vts|proto)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001062 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001063 }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001064
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001065 ;;
1066 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001067 function sgrep()
1068 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001069 find . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.\(c\|h\|cc\|cpp\|hpp\|S\|java\|kt\|xml\|sh\|mk\|aidl\|vts\|proto\)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001070 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001071 }
1072 ;;
1073esac
1074
Matt Alexanderd9c56562020-05-21 10:49:17 +00001075function gettargetarch
1076{
Raghu Gandham8da43102012-07-25 19:57:22 -07001077 get_build_var TARGET_ARCH
1078}
1079
Matt Alexanderd9c56562020-05-21 10:49:17 +00001080function ggrep()
1081{
Mike Frysinger5e479732015-09-22 18:13:48 -04001082 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.gradle" \
1083 -exec grep --color -n "$@" {} +
Jon Boekenoogencbca56f2014-04-07 10:57:38 -07001084}
1085
Matt Alexanderd9c56562020-05-21 10:49:17 +00001086function gogrep()
1087{
Orion Hodson831472d2019-10-25 11:35:15 +01001088 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.go" \
1089 -exec grep --color -n "$@" {} +
1090}
1091
Matt Alexanderd9c56562020-05-21 10:49:17 +00001092function jgrep()
1093{
Mike Frysinger5e479732015-09-22 18:13:48 -04001094 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.java" \
1095 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001096}
1097
Alistair Delva176e5342021-02-22 13:31:26 -08001098function rsgrep()
Jeff Vander Stoep1431ab82021-02-02 19:18:26 +01001099{
1100 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rs" \
1101 -exec grep --color -n "$@" {} +
1102}
1103
Taesu Leeea0cecd2020-10-28 11:05:18 +09001104function ktgrep()
1105{
1106 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.kt" \
1107 -exec grep --color -n "$@" {} +
1108}
1109
Matt Alexanderd9c56562020-05-21 10:49:17 +00001110function cgrep()
1111{
Mike Frysinger5e479732015-09-22 18:13:48 -04001112 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f \( -name '*.c' -o -name '*.cc' -o -name '*.cpp' -o -name '*.h' -o -name '*.hpp' \) \
1113 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001114}
1115
Matt Alexanderd9c56562020-05-21 10:49:17 +00001116function resgrep()
1117{
Christopher Ferris55257d22017-03-23 11:08:58 -07001118 local dir
Mike Frysinger5e479732015-09-22 18:13:48 -04001119 for dir in `find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -name res -type d`; do
1120 find $dir -type f -name '*\.xml' -exec grep --color -n "$@" {} +
1121 done
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001122}
1123
Matt Alexanderd9c56562020-05-21 10:49:17 +00001124function mangrep()
1125{
Mike Frysinger5e479732015-09-22 18:13:48 -04001126 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'AndroidManifest.xml' \
1127 -exec grep --color -n "$@" {} +
Jeff Sharkey50b61e92013-03-08 10:20:47 -08001128}
1129
Matt Alexanderd9c56562020-05-21 10:49:17 +00001130function owngrep()
1131{
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -06001132 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'OWNERS' \
1133 -exec grep --color -n "$@" {} +
1134}
1135
Matt Alexanderd9c56562020-05-21 10:49:17 +00001136function sepgrep()
1137{
Mike Frysinger5e479732015-09-22 18:13:48 -04001138 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -name sepolicy -type d \
1139 -exec grep --color -n -r --exclude-dir=\.git "$@" {} +
Alex Klyubinba5fc8e2013-05-06 14:11:48 -07001140}
1141
Matt Alexanderd9c56562020-05-21 10:49:17 +00001142function rcgrep()
1143{
Mike Frysinger5e479732015-09-22 18:13:48 -04001144 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rc*" \
1145 -exec grep --color -n "$@" {} +
Jeff Sharkeyea0068a2015-02-26 14:13:46 -08001146}
1147
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001148case `uname -s` in
1149 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001150 function mgrep()
1151 {
Orion Hodson831472d2019-10-25 11:35:15 +01001152 find -E . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -iregex '.*/(Makefile|Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001153 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001154 }
1155
Matt Alexanderd9c56562020-05-21 10:49:17 +00001156 function treegrep()
1157 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001158 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001159 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001160 }
1161
1162 ;;
1163 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001164 function mgrep()
1165 {
Orion Hodson831472d2019-10-25 11:35:15 +01001166 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -regextype posix-egrep -iregex '(.*\/Makefile|.*\/Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regextype posix-extended -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001167 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001168 }
1169
Matt Alexanderd9c56562020-05-21 10:49:17 +00001170 function treegrep()
1171 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001172 find . -name .repo -prune -o -name .git -prune -o -regextype posix-egrep -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001173 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001174 }
1175
1176 ;;
1177esac
1178
Matt Alexanderd9c56562020-05-21 10:49:17 +00001179function getprebuilt
1180{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001181 get_abs_build_var ANDROID_PREBUILTS
1182}
1183
Matt Alexanderd9c56562020-05-21 10:49:17 +00001184function tracedmdump()
1185{
Christopher Ferris55257d22017-03-23 11:08:58 -07001186 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001187 if [ ! "$T" ]; then
1188 echo "Couldn't locate the top of the tree. Try setting TOP."
1189 return
1190 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001191 local prebuiltdir=$(getprebuilt)
Raghu Gandham8da43102012-07-25 19:57:22 -07001192 local arch=$(gettargetarch)
1193 local KERNEL=$T/prebuilts/qemu-kernel/$arch/vmlinux-qemu
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001194
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001195 local TRACE=$1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001196 if [ ! "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001197 echo "usage: tracedmdump tracename"
1198 return
1199 fi
1200
Matt Alexanderd9c56562020-05-21 10:49:17 +00001201 if [ ! -r "$KERNEL" ] ; then
Jack Veenstra60116fc2009-04-09 18:12:34 -07001202 echo "Error: cannot find kernel: '$KERNEL'"
1203 return
1204 fi
1205
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001206 local BASETRACE=$(basename $TRACE)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001207 if [ "$BASETRACE" = "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001208 TRACE=$ANDROID_PRODUCT_OUT/traces/$TRACE
1209 fi
1210
1211 echo "post-processing traces..."
1212 rm -f $TRACE/qtrace.dexlist
1213 post_trace $TRACE
1214 if [ $? -ne 0 ]; then
1215 echo "***"
1216 echo "*** Error: malformed trace. Did you remember to exit the emulator?"
1217 echo "***"
1218 return
1219 fi
1220 echo "generating dexlist output..."
1221 /bin/ls $ANDROID_PRODUCT_OUT/system/framework/*.jar $ANDROID_PRODUCT_OUT/system/app/*.apk $ANDROID_PRODUCT_OUT/data/app/*.apk 2>/dev/null | xargs dexlist > $TRACE/qtrace.dexlist
1222 echo "generating dmtrace data..."
1223 q2dm -r $ANDROID_PRODUCT_OUT/symbols $TRACE $KERNEL $TRACE/dmtrace || return
1224 echo "generating html file..."
1225 dmtracedump -h $TRACE/dmtrace >| $TRACE/dmtrace.html || return
1226 echo "done, see $TRACE/dmtrace.html for details"
1227 echo "or run:"
1228 echo " traceview $TRACE/dmtrace"
1229}
1230
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001231# communicate with a running device or emulator, set up necessary state,
1232# and run the hat command.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001233function runhat()
1234{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001235 # process standard adb options
1236 local adbTarget=""
Matt Alexanderd9c56562020-05-21 10:49:17 +00001237 if [ "$1" = "-d" -o "$1" = "-e" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001238 adbTarget=$1
1239 shift 1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001240 elif [ "$1" = "-s" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001241 adbTarget="$1 $2"
1242 shift 2
1243 fi
1244 local adbOptions=${adbTarget}
Matt Alexanderd9c56562020-05-21 10:49:17 +00001245 #echo adbOptions = ${adbOptions}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001246
1247 # runhat options
1248 local targetPid=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001249
Matt Alexanderd9c56562020-05-21 10:49:17 +00001250 if [ "$targetPid" = "" ]; then
Andy McFaddenb6289852010-07-12 08:00:19 -07001251 echo "Usage: runhat [ -d | -e | -s serial ] target-pid"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001252 return
1253 fi
1254
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001255 # confirm hat is available
1256 if [ -z $(which hat) ]; then
1257 echo "hat is not available in this configuration."
1258 return
1259 fi
1260
Andy McFaddenb6289852010-07-12 08:00:19 -07001261 # issue "am" command to cause the hprof dump
Nick Kralevich9948b1e2014-07-18 15:45:38 -07001262 local devFile=/data/local/tmp/hprof-$targetPid
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001263 echo "Poking $targetPid and waiting for data..."
Dianne Hackborn6b9549f2012-09-26 15:00:59 -07001264 echo "Storing data at $devFile"
Andy McFaddenb6289852010-07-12 08:00:19 -07001265 adb ${adbOptions} shell am dumpheap $targetPid $devFile
The Android Open Source Project88b60792009-03-03 19:28:42 -08001266 echo "Press enter when logcat shows \"hprof: heap dump completed\""
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001267 echo -n "> "
1268 read
1269
The Android Open Source Project88b60792009-03-03 19:28:42 -08001270 local localFile=/tmp/$$-hprof
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001271
The Android Open Source Project88b60792009-03-03 19:28:42 -08001272 echo "Retrieving file $devFile..."
1273 adb ${adbOptions} pull $devFile $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001274
The Android Open Source Project88b60792009-03-03 19:28:42 -08001275 adb ${adbOptions} shell rm $devFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001276
The Android Open Source Project88b60792009-03-03 19:28:42 -08001277 echo "Running hat on $localFile"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001278 echo "View the output by pointing your browser at http://localhost:7000/"
1279 echo ""
Dianne Hackborn6e4e1bb2011-11-10 15:19:51 -08001280 hat -JXmx512m $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001281}
1282
Matt Alexanderd9c56562020-05-21 10:49:17 +00001283function getbugreports()
1284{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001285 local reports=(`adb shell ls /sdcard/bugreports | tr -d '\r'`)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001286
1287 if [ ! "$reports" ]; then
1288 echo "Could not locate any bugreports."
1289 return
1290 fi
1291
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001292 local report
1293 for report in ${reports[@]}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001294 do
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001295 echo "/sdcard/bugreports/${report}"
1296 adb pull /sdcard/bugreports/${report} ${report}
1297 gunzip ${report}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001298 done
1299}
1300
Matt Alexanderd9c56562020-05-21 10:49:17 +00001301function getsdcardpath()
1302{
Victoria Lease1b296b42012-08-21 15:44:06 -07001303 adb ${adbOptions} shell echo -n \$\{EXTERNAL_STORAGE\}
1304}
1305
Matt Alexanderd9c56562020-05-21 10:49:17 +00001306function getscreenshotpath()
1307{
Victoria Lease1b296b42012-08-21 15:44:06 -07001308 echo "$(getsdcardpath)/Pictures/Screenshots"
1309}
1310
Matt Alexanderd9c56562020-05-21 10:49:17 +00001311function getlastscreenshot()
1312{
Victoria Lease1b296b42012-08-21 15:44:06 -07001313 local screenshot_path=$(getscreenshotpath)
1314 local screenshot=`adb ${adbOptions} ls ${screenshot_path} | grep Screenshot_[0-9-]*.*\.png | sort -rk 3 | cut -d " " -f 4 | head -n 1`
Matt Alexanderd9c56562020-05-21 10:49:17 +00001315 if [ "$screenshot" = "" ]; then
Victoria Lease1b296b42012-08-21 15:44:06 -07001316 echo "No screenshots found."
1317 return
1318 fi
1319 echo "${screenshot}"
1320 adb ${adbOptions} pull ${screenshot_path}/${screenshot}
1321}
1322
Matt Alexanderd9c56562020-05-21 10:49:17 +00001323function startviewserver()
1324{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001325 local port=4939
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001326 if [ $# -gt 0 ]; then
1327 port=$1
1328 fi
1329 adb shell service call window 1 i32 $port
1330}
1331
Matt Alexanderd9c56562020-05-21 10:49:17 +00001332function stopviewserver()
1333{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001334 adb shell service call window 2
1335}
1336
Matt Alexanderd9c56562020-05-21 10:49:17 +00001337function isviewserverstarted()
1338{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001339 adb shell service call window 3
1340}
1341
Matt Alexanderd9c56562020-05-21 10:49:17 +00001342function key_home()
1343{
Romain Guyb84049a2010-10-04 16:56:11 -07001344 adb shell input keyevent 3
1345}
1346
Matt Alexanderd9c56562020-05-21 10:49:17 +00001347function key_back()
1348{
Romain Guyb84049a2010-10-04 16:56:11 -07001349 adb shell input keyevent 4
1350}
1351
Matt Alexanderd9c56562020-05-21 10:49:17 +00001352function key_menu()
1353{
Romain Guyb84049a2010-10-04 16:56:11 -07001354 adb shell input keyevent 82
1355}
1356
Matt Alexanderd9c56562020-05-21 10:49:17 +00001357function smoketest()
1358{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001359 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1360 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1361 return
1362 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001363 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001364 if [ ! "$T" ]; then
1365 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1366 return
1367 fi
1368
Ying Wang9cd17642012-12-13 10:52:07 -08001369 (\cd "$T" && mmm tests/SmokeTest) &&
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001370 adb uninstall com.android.smoketest > /dev/null &&
1371 adb uninstall com.android.smoketest.tests > /dev/null &&
1372 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTestApp.apk &&
1373 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTest.apk &&
1374 adb shell am instrument -w com.android.smoketest.tests/android.test.InstrumentationTestRunner
1375}
1376
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001377# simple shortcut to the runtest command
Matt Alexanderd9c56562020-05-21 10:49:17 +00001378function runtest()
1379{
Christopher Ferris55257d22017-03-23 11:08:58 -07001380 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001381 if [ ! "$T" ]; then
1382 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1383 return
1384 fi
Brett Chabot3fb149d2009-10-21 20:05:26 -07001385 ("$T"/development/testrunner/runtest.py $@)
Brett Chabot762748c2009-03-27 10:25:11 -07001386}
1387
The Android Open Source Project88b60792009-03-03 19:28:42 -08001388function godir () {
1389 if [[ -z "$1" ]]; then
1390 echo "Usage: godir <regex>"
1391 return
1392 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001393 local T=$(gettop)
1394 local FILELIST
Matt Alexanderd9c56562020-05-21 10:49:17 +00001395 if [ ! "$OUT_DIR" = "" ]; then
Brian Carlstromf2257422015-09-30 20:28:54 -07001396 mkdir -p $OUT_DIR
1397 FILELIST=$OUT_DIR/filelist
1398 else
1399 FILELIST=$T/filelist
1400 fi
1401 if [[ ! -f $FILELIST ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001402 echo -n "Creating index..."
Brian Carlstromf2257422015-09-30 20:28:54 -07001403 (\cd $T; find . -wholename ./out -prune -o -wholename ./.repo -prune -o -type f > $FILELIST)
The Android Open Source Project88b60792009-03-03 19:28:42 -08001404 echo " Done"
1405 echo ""
1406 fi
1407 local lines
Brian Carlstromf2257422015-09-30 20:28:54 -07001408 lines=($(\grep "$1" $FILELIST | sed -e 's/\/[^/]*$//' | sort | uniq))
Matt Alexanderd9c56562020-05-21 10:49:17 +00001409 if [[ ${#lines[@]} = 0 ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001410 echo "Not found"
1411 return
1412 fi
1413 local pathname
1414 local choice
1415 if [[ ${#lines[@]} > 1 ]]; then
1416 while [[ -z "$pathname" ]]; do
1417 local index=1
1418 local line
1419 for line in ${lines[@]}; do
1420 printf "%6s %s\n" "[$index]" $line
Doug Zongker29034982011-04-22 08:16:56 -07001421 index=$(($index + 1))
The Android Open Source Project88b60792009-03-03 19:28:42 -08001422 done
1423 echo
1424 echo -n "Select one: "
1425 unset choice
1426 read choice
1427 if [[ $choice -gt ${#lines[@]} || $choice -lt 1 ]]; then
1428 echo "Invalid choice"
1429 continue
1430 fi
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001431 pathname=${lines[@]:$(($choice-1)):1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001432 done
1433 else
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001434 pathname=${lines[@]:0:1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001435 fi
Ying Wang9cd17642012-12-13 10:52:07 -08001436 \cd $T/$pathname
The Android Open Source Project88b60792009-03-03 19:28:42 -08001437}
1438
Steven Moreland62054a42018-12-06 10:11:40 -08001439# Update module-info.json in out.
1440function refreshmod() {
1441 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1442 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1443 return 1
1444 fi
1445
1446 echo "Refreshing modules (building module-info.json). Log at $ANDROID_PRODUCT_OUT/module-info.json.build.log." >&2
1447
1448 # for the output of the next command
1449 mkdir -p $ANDROID_PRODUCT_OUT || return 1
1450
1451 # Note, can't use absolute path because of the way make works.
Alessandro Astonec8771be2020-05-10 11:27:57 +02001452 m $(get_build_var PRODUCT_OUT)/module-info.json \
Steven Moreland62054a42018-12-06 10:11:40 -08001453 > $ANDROID_PRODUCT_OUT/module-info.json.build.log 2>&1
1454}
1455
Cole Faust24c36db2021-01-23 02:39:37 +00001456# Verifies that module-info.txt exists, creating it if it doesn't.
1457function verifymodinfo() {
Steven Moreland62054a42018-12-06 10:11:40 -08001458 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1459 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1460 return 1
1461 fi
1462
1463 if [ ! -f "$ANDROID_PRODUCT_OUT/module-info.json" ]; then
1464 echo "Could not find module-info.json. It will only be built once, and it can be updated with 'refreshmod'" >&2
1465 refreshmod || return 1
1466 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001467}
1468
1469# List all modules for the current device, as cached in module-info.json. If any build change is
1470# made and it should be reflected in the output, you should run 'refreshmod' first.
1471function allmod() {
1472 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001473
LuK1337b6a78192020-01-12 03:12:17 +01001474 python -c "import json; print('\n'.join(sorted(json.load(open('$ANDROID_PRODUCT_OUT/module-info.json')).keys())))"
Steven Moreland62054a42018-12-06 10:11:40 -08001475}
1476
Joe Onorato2c1aa472021-02-25 16:42:39 -08001477# Get the path of a specific module in the android tree, as cached in module-info.json.
1478# If any build change is made, and it should be reflected in the output, you should run
1479# 'refreshmod' first. Note: This is the inverse of dirmods.
Rett Berg78d1c932019-01-24 14:34:23 -08001480function pathmod() {
Steven Moreland62054a42018-12-06 10:11:40 -08001481 if [[ $# -ne 1 ]]; then
Rett Berg78d1c932019-01-24 14:34:23 -08001482 echo "usage: pathmod <module>" >&2
Steven Moreland62054a42018-12-06 10:11:40 -08001483 return 1
1484 fi
1485
Cole Faust24c36db2021-01-23 02:39:37 +00001486 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001487
1488 local relpath=$(python -c "import json, os
1489module = '$1'
1490module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1491if module not in module_info:
1492 exit(1)
LuK1337b6a78192020-01-12 03:12:17 +01001493print(module_info[module]['path'][0])" 2>/dev/null)
Steven Moreland62054a42018-12-06 10:11:40 -08001494
1495 if [ -z "$relpath" ]; then
1496 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)." >&2
1497 return 1
1498 else
Rett Berg78d1c932019-01-24 14:34:23 -08001499 echo "$ANDROID_BUILD_TOP/$relpath"
Steven Moreland62054a42018-12-06 10:11:40 -08001500 fi
1501}
1502
Joe Onorato2c1aa472021-02-25 16:42:39 -08001503# Get the path of a specific module in the android tree, as cached in module-info.json.
1504# If any build change is made, and it should be reflected in the output, you should run
1505# 'refreshmod' first. Note: This is the inverse of pathmod.
1506function dirmods() {
1507 if [[ $# -ne 1 ]]; then
1508 echo "usage: dirmods <path>" >&2
1509 return 1
1510 fi
1511
1512 verifymodinfo || return 1
1513
1514 python -c "import json, os
1515dir = '$1'
1516while dir.endswith('/'):
1517 dir = dir[:-1]
1518prefix = dir + '/'
1519module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1520results = set()
1521for m in module_info.values():
1522 for path in m.get(u'path', []):
1523 if path == dir or path.startswith(prefix):
1524 name = m.get(u'module_name')
1525 if name:
1526 results.add(name)
1527for name in sorted(results):
1528 print(name)
1529"
1530}
1531
1532
Rett Berg78d1c932019-01-24 14:34:23 -08001533# Go to a specific module in the android tree, as cached in module-info.json. If any build change
1534# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1535function gomod() {
1536 if [[ $# -ne 1 ]]; then
1537 echo "usage: gomod <module>" >&2
1538 return 1
1539 fi
1540
1541 local path="$(pathmod $@)"
1542 if [ -z "$path" ]; then
1543 return 1
1544 fi
1545 cd $path
1546}
1547
Cole Faust24c36db2021-01-23 02:39:37 +00001548# Gets the list of a module's installed outputs, as cached in module-info.json.
1549# If any build change is made, and it should be reflected in the output, you should run 'refreshmod' first.
1550function outmod() {
1551 if [[ $# -ne 1 ]]; then
1552 echo "usage: outmod <module>" >&2
1553 return 1
1554 fi
1555
1556 verifymodinfo || return 1
1557
1558 local relpath
1559 relpath=$(python -c "import json, os
1560module = '$1'
1561module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1562if module not in module_info:
1563 exit(1)
1564for output in module_info[module]['installed']:
1565 print(os.path.join('$ANDROID_BUILD_TOP', output))" 2>/dev/null)
1566
1567 if [ $? -ne 0 ]; then
1568 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)" >&2
1569 return 1
1570 elif [ ! -z "$relpath" ]; then
1571 echo "$relpath"
1572 fi
1573}
1574
1575# adb install a module's apk, as cached in module-info.json. If any build change
1576# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1577# Usage: installmod [adb install arguments] <module>
1578# For example: installmod -r Dialer -> adb install -r /path/to/Dialer.apk
1579function installmod() {
1580 if [[ $# -eq 0 ]]; then
1581 echo "usage: installmod [adb install arguments] <module>" >&2
1582 return 1
1583 fi
1584
1585 local _path
1586 _path=$(outmod ${@:$#:1})
1587 if [ $? -ne 0 ]; then
1588 return 1
1589 fi
1590
1591 _path=$(echo "$_path" | grep -E \\.apk$ | head -n 1)
1592 if [ -z "$_path" ]; then
1593 echo "Module '$1' does not produce a file ending with .apk (try 'refreshmod' if there have been build changes?)" >&2
1594 return 1
1595 fi
1596 local length=$(( $# - 1 ))
1597 echo adb install ${@:1:$length} $_path
1598 adb install ${@:1:$length} $_path
1599}
1600
dimitry73b84812018-12-11 18:06:00 +01001601function _complete_android_module_names() {
Steven Moreland62054a42018-12-06 10:11:40 -08001602 local word=${COMP_WORDS[COMP_CWORD]}
1603 COMPREPLY=( $(allmod | grep -E "^$word") )
1604}
1605
Alex Rayf0d08eb2013-03-08 15:15:06 -08001606# Print colored exit condition
1607function pez {
Michael Wrighteb733842013-03-08 17:34:02 -08001608 "$@"
1609 local retval=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +00001610 if [ $retval -ne 0 ]
1611 then
Jacky Cao89483b82015-05-15 22:12:53 +08001612 echo $'\E'"[0;31mFAILURE\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001613 else
Jacky Cao89483b82015-05-15 22:12:53 +08001614 echo $'\E'"[0;32mSUCCESS\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001615 fi
1616 return $retval
Alex Rayf0d08eb2013-03-08 15:15:06 -08001617}
1618
Matt Alexanderd9c56562020-05-21 10:49:17 +00001619function get_make_command()
1620{
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001621 # If we're in the top of an Android tree, use soong_ui.bash instead of make
1622 if [ -f build/soong/soong_ui.bash ]; then
Dan Willemsene9842242017-07-28 13:00:13 -07001623 # Always use the real make if -C is passed in
1624 for arg in "$@"; do
1625 if [[ $arg == -C* ]]; then
1626 echo command make
1627 return
1628 fi
1629 done
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001630 echo build/soong/soong_ui.bash --make-mode
1631 else
1632 echo command make
1633 fi
Ying Wanged21d4c2014-08-24 22:14:19 -07001634}
1635
Matt Alexanderd9c56562020-05-21 10:49:17 +00001636function _wrap_build()
1637{
Sasha Smundak9f27cc02019-01-31 13:25:31 -08001638 if [[ "${ANDROID_QUIET_BUILD:-}" == true ]]; then
1639 "$@"
1640 return $?
1641 fi
Ed Heylcc6be0a2014-06-18 14:55:58 -07001642 local start_time=$(date +"%s")
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001643 "$@"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001644 local ret=$?
1645 local end_time=$(date +"%s")
1646 local tdiff=$(($end_time-$start_time))
1647 local hours=$(($tdiff / 3600 ))
1648 local mins=$((($tdiff % 3600) / 60))
1649 local secs=$(($tdiff % 60))
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001650 local ncolors=$(tput colors 2>/dev/null)
1651 if [ -n "$ncolors" ] && [ $ncolors -ge 8 ]; then
Jacky Cao89483b82015-05-15 22:12:53 +08001652 color_failed=$'\E'"[0;31m"
1653 color_success=$'\E'"[0;32m"
1654 color_reset=$'\E'"[00m"
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001655 else
1656 color_failed=""
1657 color_success=""
1658 color_reset=""
1659 fi
Ed Heylcc6be0a2014-06-18 14:55:58 -07001660 echo
Matt Alexanderd9c56562020-05-21 10:49:17 +00001661 if [ $ret -eq 0 ] ; then
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001662 echo -n "${color_success}#### build completed successfully "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001663 else
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001664 echo -n "${color_failed}#### failed to build some targets "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001665 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +00001666 if [ $hours -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001667 printf "(%02g:%02g:%02g (hh:mm:ss))" $hours $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001668 elif [ $mins -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001669 printf "(%02g:%02g (mm:ss))" $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001670 elif [ $secs -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001671 printf "(%s seconds)" $secs
1672 fi
Jacky Cao89483b82015-05-15 22:12:53 +08001673 echo " ####${color_reset}"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001674 echo
1675 return $ret
1676}
1677
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001678function _trigger_build()
1679(
1680 local -r bc="$1"; shift
1681 if T="$(gettop)"; then
1682 _wrap_build "$T/build/soong/soong_ui.bash" --build-mode --${bc} --dir="$(pwd)" "$@"
1683 else
1684 echo "Couldn't locate the top of the tree. Try setting TOP."
1685 fi
1686)
1687
1688function m()
1689(
1690 _trigger_build "all-modules" "$@"
1691)
1692
1693function mm()
1694(
1695 _trigger_build "modules-in-a-dir-no-deps" "$@"
1696)
1697
1698function mmm()
1699(
1700 _trigger_build "modules-in-dirs-no-deps" "$@"
1701)
1702
1703function mma()
1704(
1705 _trigger_build "modules-in-a-dir" "$@"
1706)
1707
1708function mmma()
1709(
1710 _trigger_build "modules-in-dirs" "$@"
1711)
1712
Matt Alexanderd9c56562020-05-21 10:49:17 +00001713function make()
1714{
Dan Willemsene9842242017-07-28 13:00:13 -07001715 _wrap_build $(get_make_command "$@") "$@"
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001716}
1717
Matt Alexanderd9c56562020-05-21 10:49:17 +00001718function provision()
1719{
David Zeuthen1b126ff2015-09-30 17:10:48 -04001720 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1721 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1722 return 1
1723 fi
1724 if [ ! -e "$ANDROID_PRODUCT_OUT/provision-device" ]; then
1725 echo "There is no provisioning script for the device." >&2
1726 return 1
1727 fi
1728
1729 # Check if user really wants to do this.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001730 if [ "$1" = "--no-confirmation" ]; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001731 shift 1
1732 else
1733 echo "This action will reflash your device."
1734 echo ""
1735 echo "ALL DATA ON THE DEVICE WILL BE IRREVOCABLY ERASED."
1736 echo ""
Marie Janssen4afc2c02015-11-10 10:41:15 -08001737 echo -n "Are you sure you want to do this (yes/no)? "
1738 read
Matt Alexanderd9c56562020-05-21 10:49:17 +00001739 if [[ "${REPLY}" != "yes" ]] ; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001740 echo "Not taking any action. Exiting." >&2
1741 return 1
1742 fi
1743 fi
1744 "$ANDROID_PRODUCT_OUT/provision-device" "$@"
1745}
1746
Jim Tanga881a252018-06-19 16:34:41 +08001747# Zsh needs bashcompinit called to support bash-style completion.
Patrik Fimmldf248e62018-10-15 18:15:12 +02001748function enable_zsh_completion() {
1749 # Don't override user's options if bash-style completion is already enabled.
1750 if ! declare -f complete >/dev/null; then
1751 autoload -U compinit && compinit
1752 autoload -U bashcompinit && bashcompinit
1753 fi
Jim Tanga881a252018-06-19 16:34:41 +08001754}
1755
1756function validate_current_shell() {
1757 local current_sh="$(ps -o command -p $$)"
1758 case "$current_sh" in
Raphael Moll70a86b02011-06-20 16:03:14 -07001759 *bash*)
Jim Tanga881a252018-06-19 16:34:41 +08001760 function check_type() { type -t "$1"; }
Raphael Moll70a86b02011-06-20 16:03:14 -07001761 ;;
Jim Tanga881a252018-06-19 16:34:41 +08001762 *zsh*)
1763 function check_type() { type "$1"; }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001764 enable_zsh_completion ;;
Raphael Moll70a86b02011-06-20 16:03:14 -07001765 *)
Jim Tanga881a252018-06-19 16:34:41 +08001766 echo -e "WARNING: Only bash and zsh are supported.\nUse of other shell would lead to erroneous results."
Raphael Moll70a86b02011-06-20 16:03:14 -07001767 ;;
1768 esac
Jim Tanga881a252018-06-19 16:34:41 +08001769}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001770
1771# Execute the contents of any vendorsetup.sh files we can find.
Dan Willemsend855a722019-02-12 15:52:36 -08001772# Unless we find an allowed-vendorsetup_sh-files file, in which case we'll only
1773# load those.
1774#
1775# This allows loading only approved vendorsetup.sh files
Jim Tanga881a252018-06-19 16:34:41 +08001776function source_vendorsetup() {
Jim Tangc4dba1d2019-07-25 16:54:27 +08001777 unset VENDOR_PYTHONPATH
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001778 local T="$(gettop)"
Dan Willemsend855a722019-02-12 15:52:36 -08001779 allowed=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001780 for f in $(cd "$T" && find -L device vendor product -maxdepth 4 -name 'allowed-vendorsetup_sh-files' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001781 if [ -n "$allowed" ]; then
1782 echo "More than one 'allowed_vendorsetup_sh-files' file found, not including any vendorsetup.sh files:"
1783 echo " $allowed"
1784 echo " $f"
1785 return
1786 fi
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001787 allowed="$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001788 done
1789
1790 allowed_files=
1791 [ -n "$allowed" ] && allowed_files=$(cat "$allowed")
Jim Tanga881a252018-06-19 16:34:41 +08001792 for dir in device vendor product; do
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001793 for f in $(cd "$T" && test -d $dir && \
Jim Tanga881a252018-06-19 16:34:41 +08001794 find -L $dir -maxdepth 4 -name 'vendorsetup.sh' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001795
1796 if [[ -z "$allowed" || "$allowed_files" =~ $f ]]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001797 echo "including $f"; . "$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001798 else
1799 echo "ignoring $f, not in $allowed"
1800 fi
Jim Tanga881a252018-06-19 16:34:41 +08001801 done
1802 done
1803}
Kenny Root52aa81c2011-07-15 11:07:06 -07001804
Dan Albertbab814f2020-08-26 15:34:53 -07001805function showcommands() {
1806 local T=$(gettop)
1807 if [[ -z "$TARGET_PRODUCT" ]]; then
1808 >&2 echo "TARGET_PRODUCT not set. Run lunch."
1809 return
1810 fi
1811 case $(uname -s) in
1812 Darwin)
1813 PREBUILT_NAME=darwin-x86
1814 ;;
1815 Linux)
1816 PREBUILT_NAME=linux-x86
1817 ;;
1818 *)
1819 >&2 echo Unknown host $(uname -s)
1820 return
1821 ;;
1822 esac
1823 if [[ -z "$OUT_DIR" ]]; then
1824 if [[ -z "$OUT_DIR_COMMON_BASE" ]]; then
1825 OUT_DIR=out
1826 else
1827 OUT_DIR=${OUT_DIR_COMMON_BASE}/${PWD##*/}
1828 fi
1829 fi
1830 if [[ "$1" == "--regenerate" ]]; then
1831 shift 1
1832 NINJA_ARGS="-t commands $@" m
1833 else
1834 (cd $T && prebuilts/build-tools/$PREBUILT_NAME/bin/ninja \
1835 -f $OUT_DIR/combined-${TARGET_PRODUCT}.ninja \
1836 -t commands "$@")
1837 fi
1838}
1839
Jim Tanga881a252018-06-19 16:34:41 +08001840validate_current_shell
1841source_vendorsetup
Kenny Root52aa81c2011-07-15 11:07:06 -07001842addcompletions